# Class Practice Exercises

## Answer each of the following:

A program module in C is called a(n)           .

A function is invoked with a(n)           .

A variable that’s known only within the function in which it’s defined is called a(n)____________.

The____________statement in a called function is used to pass the value of an expression back to the calling function.

Keyword_______________is used in a function header to indicate that a function does not return a value or to indicate that a function contains no parameters.

The_____________-of an identifier is the portion of the program in which the identifier can be used.

The three ways to return control from a called function to a caller are___________,_____________and_______________.

A(n)______________allows the compiler to check the number, types, and order of the arguments passed to a function.

The_____________function is used to produce random numbers.

The_____________function is used to set the random number seed to randomize a program.

The storage-class specifiers are_________,___________,__________and___________.

Variables declared in a block or in the parameter list of a function are assumed to be of storage class____________-unless specified otherwise.

A non-static variable defined outside any block or function is a(n)_____________variable.

For a local variable in a function to retain its value between calls to the function, it must be declared with the____________storage-class specifier.

The four possible scopes of an identifier are________,_____________,___________--and____________.

A function that calls itself either directly or indirectly is a(n)______________function.

A recursive function typically has two components: one that provides a means for the recursion to terminate by testing for a(n)___________________case, and one that expresses the problem as a recursive call for a slightly simpler problem than the original call.

## For the following program, state the scope (either function scope, file scope, block scope or function-prototype scope) of each of the following elements.

The variable x in main.

The variable y in cube.

The function cube.

The function main.

The function prototype for cube.

The identifier y in the function prototype for cube.

```c
#include <stdio.h>
int cube ( int y );

int main( void )
{
    int x;

    for ( x = 1; x <= 10; ++x )
        printf( "%d\n", cube( x ) );
}

int cube( int y )
{
    return y * y * y;
}
```

## Write a program that tests whether the examples of the math library function calls actually produce the indicated results.

 ## Give the function header for each of the following functions.

Function hypotenuse that takes two double-precision floating-point arguments, side1 and side2, and returns a double-precision floating-point result.

Function smallest that takes three integers, x, y, z, and returns an integer.

Function instructions that does not receive any arguments and does not return a value. [Note: Such functions are commonly used to display instructions to a user.]

Function intToFloat that takes an integer argument, number, and returns a floating-point result.

## Write a declaration for floating-point variable lastVal that’s to retain its value between calls to the function in which it’s defined.

## Find the error in each of the following program segme nts and explain how the error can be corrected 

a.
```c
int g( void )
{
    printf( "%s", Inside function g\n" );
    int h( void )
    {
        printf( "%s", Inside function h\n" );
    }
}
```
b. 
```c
int sum( int x, int y )
{
    int result;
    result = x + y;
}
```

c. 
```c
void f( float a );
{
    float a;
    printf( "%f", a );
}
```

d. 
```c
int sum( int n )
{
    if ( 0 == n ) {
        return 0; //
    }
    else {
        n + sum( n - 1 );
    }
}
```

e.
```c
void product( void )
{
    int a, b, c, result;
    printf( "%s", "Enter three integers: ")
    scanf( "%d%d%d", &a, &b, &c );
    result = a * b * c;
    printf ( "Result is %d", result );
    return result;
}
```







